import 'dart:collection';

class ListStack<E> {
  ListQueue<E> _list = ListQueue();

  /// check if the stack is empty.
  bool get isEmpty => _list.isEmpty;

  /// check if the stack is not empty.
  bool get isNotEmpty => _list.isNotEmpty;

  /// check if the stack is not empty.
  int get size => _list.length;

  /// push element in top of the stack.
  E push(E item) {
    _list.addLast(item);
    return item;
  }
  
  /// get the top of the stack and delete it.
  E pop() {
    E item = _list.last;
    _list.removeLast();
    return item;
  }

  /// get the top of the stack without deleting it.
  E peek() {
    return _list.last;
  }

  void clear() {
    _list = new ListQueue();
  }
}