import 'package:http/http.dart' as http;
import 'dart:io';
import 'dart:async';

class ConnectionUtils {
  static Future<bool> isResponseSuccessful(String url, {int timeout}) async
  {
    try{
      final response = await http.head(url);
      return response.statusCode >= 200 || response.statusCode < 300;
    }catch(e){
      print(e);
    }
    return false;
  }

  static Future<bool> isResponseOnline(String url, {int timeout}) async
  {
    final response = await http.head(url);

    switch(response.statusCode){
      case HttpStatus.ok:
      case HttpStatus.created:
      case HttpStatus.accepted:
      case HttpStatus.nonAuthoritativeInformation:
      case HttpStatus.noContent:
      case HttpStatus.resetContent:
      case HttpStatus.partialContent:
      case HttpStatus.notModified:
      case HttpStatus.useProxy:
      case HttpStatus.badRequest:
      case HttpStatus.unauthorized:
      case HttpStatus.paymentRequired:
      case HttpStatus.forbidden:
      case HttpStatus.proxyAuthenticationRequired:
      case HttpStatus.lengthRequired:
      case HttpStatus.internalServerError:
      case HttpStatus.badGateway:
      return true;
    }
    return false;
  }
}