import 'package:flutter/material.dart';

abstract class ILocalize<T>
{
  ILocalize.get();

  T valueOf(String name) => null;
  List<T> get values;
  List<String> get valuesAsString {
    List<String> valuesAsString = [];
    values?.forEach((value) => valuesAsString.add(nameOf(value)));
    return valuesAsString;
  }

  String nameOf(T value) {
    try{return value?.toString()?.split(".")?.last;}catch(e){print(e);}
    return null;
  }
  List<String> get names {
    List<String> namesAsString = [];
    values?.forEach((value) => namesAsString.add(nameOf(value)));
    return namesAsString;
  }

  String locale(T value, {BuildContext context}) => "Locale not found";
  List<String> get locales {
    List<String> locales = [];
    values?.forEach((value) => locales.add(locale(value)));
    return locales;
  }

  String extended(T value) => "Extended not found";
}
