import 'package:flutter/material.dart';

class LocaleUtils{

  static Map<String, dynamic> toJson(Locale value) => {
    'locale': value?.toLanguageTag()
  };
  static Locale fromJson(Map<String, dynamic> json) => json != null ? fromLanguageTag(json['locale']) : null;

  static Locale fromLanguageTag(String languageTag) {
    if(languageTag == null) return null;
    List<String> split = languageTag.split('-');
    if(split != null){
      switch(split.length){
        case 1: return Locale(split[0]);
        case 2: return Locale(split[0], split[1]);
        case 3: return Locale.fromSubtags(languageCode: split[0], scriptCode: split[1], countryCode: split[2],);
      }
    }
    return null;
  }
}