import 'package:flutter/material.dart';
import 'dart:ui';

class ScreenUtils
{
   /// sw600dp qualifier is the breakpoint for popular 7-inch Android tablets.
   /// sw means smallest width, and the number 600 here is a common breakpoint
   /// for a typical 7-inch tablet.
  static const double sw600dp = 600;

  static bool isMobileScreen([BuildContext context]) {
    if(context != null) return MediaQuery.of(context).size.shortestSide < sw600dp;
//    return MediaQueryData.fromWindow(window).size.shortestSide < sw600dp;
    return (window.physicalSize / window.devicePixelRatio).shortestSide < sw600dp;//this is the same as MediaQueryData.fromWindow(window).size.shortestSide < sw600dp but faster
  }
  static bool isTabletScreen([BuildContext context]) => !isMobileScreen(context);
  static bool isPortrait([BuildContext context]) {
    if(context != null) return MediaQuery.of(context).orientation == Orientation.portrait;
    return MediaQueryData.fromWindow(window).orientation == Orientation.portrait;
  }
  static bool isLandscape([BuildContext context]) {
    if(context != null) return MediaQuery.of(context).orientation == Orientation.landscape;
    return MediaQueryData.fromWindow(window).orientation == Orientation.landscape;
  }

}
