import 'package:shared_preferences/shared_preferences.dart';

class SharedPreferencesUtils
{
  static SharedPreferences _sharedPreferences;

  //Singleton Pattern
  static init() async => _sharedPreferences = await SharedPreferences.getInstance();

  static void putBool(String key, bool value) => _sharedPreferences != null ? _sharedPreferences.setBool(key, value) : null; 

  static bool getBool(String key, {bool defaultValue})
  {
    if(_sharedPreferences == null || key == null) return null;
    bool value = _sharedPreferences.getBool(key);
    return value != null ? value : defaultValue;
  }

  static void putString(String key, String value) => _sharedPreferences != null ? _sharedPreferences.setString(key, value) : null;

  static String getString(String key, {String defaultValue})
  {
    if(_sharedPreferences == null || key == null) return null;
    String value = _sharedPreferences.getString(key);
    return value != null ? value : defaultValue;
  }

  static void putInt(String key, int value) => _sharedPreferences != null ? _sharedPreferences.setInt(key, value) : null;

  static int getInt(String key, {int defaultValue})
  {
    if(_sharedPreferences == null || key == null) return null;
    int value = _sharedPreferences.getInt(key);
    return value != null ? value : defaultValue;
  }

  static void putDouble(String key, double value) => _sharedPreferences != null ? _sharedPreferences.setDouble(key, value) : null;

  static double getDouble(String key, {double defaultValue})
  {
    if(_sharedPreferences == null || key == null) return null;
    double value = _sharedPreferences.getDouble(key);
    return value != null ? value : defaultValue;
  }

  static void putStringList(String key, List<String> value) => _sharedPreferences != null ? _sharedPreferences.setStringList(key, value) : null;

  static List<String> getStringList(String key, {List<String> defaultValue})
  {
    if(_sharedPreferences == null || key == null) return null;
    List<String> value = _sharedPreferences.getStringList(key);
    return value != null ? value : defaultValue;
  }
}
